#include "stdafx.h"
#include "KeyInjectModule.h"
#include "KeyInjectModuleDlg.h"
#include "MSRItfUSBHID.h"
#include "Thread.h"
#include "IDT_DUKPT.h"


#include <time.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString StrBDK = "0123456789ABCDEFFEDCBA9876543210";
CString StrReaderStatus = "Please Connect SecureMOIR Reader!";
CString StrCardData;
CString StrResponse;
CString StrHID_Data;
CString StrUSBKB;

const TCHAR CR[] = {13, 0};

int USBKB_Data_Length;
int EncodingType;
int TimeoutCounter;
int LenHexData;
int Data_Length;
int	nReader = -1;

BYTE CardData[1000];
BYTE HexData[1000];
BYTE EncryptedData[8];
BYTE m_TrackBuffer[1000];
BYTE challenge[16];
BYTE KSNglb[10];
BYTE USBKB_Data[10];
BYTE CardDataBuffer[1000];
BYTE glm_nksn[10];

ULONG BufferLength = 1000;

bool bHex = true;	// Output format: TRUE - Hex, FALSE - ASCII
BOOL bActivation = false;
BOOL bMOIR = true;  // MOIR Envelope 
BOOL bBDK = false;
BOOL bUpdateDisplay = false;
BOOL bGetChallenge = false;
BOOL bAuthentication = false;
BOOL bDUKPT = false;	
BOOL bChecked = false;
BOOL bTimeout = false;


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUT };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg dialog

CKeyInjectModuleDlg::CKeyInjectModuleDlg(CWnd* pParent /*=NULL*/)
: CDialog(CKeyInjectModuleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyInjectModuleDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeyInjectModuleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyInjectModuleDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeyInjectModuleDlg, CDialog)
//{{AFX_MSG_MAP(CKeyInjectModuleDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_SCRIPT, OnDecrypt)
	ON_BN_CLICKED(IDC_INPUT_KEY, OnInputKey)
	ON_BN_CLICKED(IDC_ACTAUTH, OnActivateAuthentication)
	ON_BN_CLICKED(IDC_ACTRPLY, OnActivateChallengeReply)
	ON_BN_CLICKED(IDC_DEACTRPLY, OnDeactivateChallengeReply)
	ON_BN_CLICKED(IDC_STATUS, OnGetReaderStatus)
	ON_BN_CLICKED(IDC_DECODE_ASCII, OnDecodeAscii)
	ON_BN_CLICKED(IDC_DECODE_HEX, OnDecodeHex)
	ON_COMMAND(ID_MENU_SetDefault, OnMENUSetDefault)
	ON_COMMAND(ID_MENU_ReadConfiguration, OnMENUReadConfiguration)
	ON_COMMAND(ID_MENU_ReadFirmware, OnMENUReadFirmware)
	ON_COMMAND(ID_MENU_ReadOnInsertionAndWithdrawal, OnMENUReadOnInsertionAndWithdrawal)
	ON_COMMAND(ID_MENU_ReadOnInsertion, OnMENUReadOnInsertion)
	ON_COMMAND(ID_MENU_ReportOnWithdrawal, OnMENUReportOnWithdrawal)
	ON_COMMAND(ID_MENU_ReadOnWithdrawal, OnMENUReadOnWithdrawal)
	ON_COMMAND(ID_MENU_About, OnMENUAbout)
	ON_COMMAND(ID_MENU_TDES, OnMenuTdes)
	ON_COMMAND(ID_MENU_AES, OnMenuAes)
	ON_COMMAND(ID_MENU_SetPrePANClrData, OnMENUSetPrePANClrData)
	ON_COMMAND(ID_MENU_SetPostPANClrData, OnMENUSetPostPANClrData)
	ON_COMMAND(ID_MENU_SetMaskCharID, OnMENUSetMaskChar)
	ON_COMMAND(ID_MENU_RawData, OnMENURawData)
	ON_COMMAND(ID_MENU_MSREnable, OnMENUMSREnable)
	ON_COMMAND(ID_MENU_MSRDisable, OnMENUMSRDisable)
	ON_COMMAND(ID_MENU_SecurityLevel, OnMENUSecurityLevel)	
	ON_COMMAND(ID_MENU_GetDeviceSN, OnMENUGetDeviceSN)
	ON_COMMAND(ID_MENU_GETKSN, OnMenuGetksn)
	ON_COMMAND(ID_MENU_USBKB_MODE, OnMenuUsbkbMode)
	ON_COMMAND(ID_MENU_HID_MODE, OnMenuHidMode)
	ON_COMMAND(ID_MENU_OriginalEncryptionFormat, OnMENUOriginalEncryptionFormat)
	ON_COMMAND(ID_MENU_EnhancedEncryptionFormat, OnMENUEnhancedEncryptionFormat)
	ON_COMMAND(ID_MENU_ForceEncryptAllTracks, OnMENUForceEncryptAllTracks)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg message handlers

BOOL CKeyInjectModuleDlg::OnInitDialog()
{
	
	CDialog::OnInitDialog();
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Add the Menu 
	m_menu.LoadMenu(IDR_MENU);
	SetMenu(&m_menu);
	
	// Timer interval = 500ms
	m_Timer = SetTimer(1, 500, 0);  
	
	// Thread for reading HID interface track data
	CThread* pThread;
    pThread = new CThread();
    pThread->CreateThread();
    pThread->PostThreadMessage(WM_THREADMESSAGE,NULL,NULL);

	// Reader Connection 
	m_font.CreatePointFont(120,"Arial");
	GetDlgItem(IDC_READER_STATUS)->SetFont(&m_font);
	GetDlgItem(IDC_READER_STATUS)->SetWindowText(StrReaderStatus);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeyInjectModuleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeyInjectModuleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



//make the ASCII format Hex command to real hex commands.
//pcbCmd IN: the size of bysCmd buffer, OUT: the real bytes counts of the command
BOOL CKeyInjectModuleDlg::MakeCommand(CString& strCmd, PBYTE bysCmd, int* pcbCmd)
{	
	CString strTemp;
	BYTE byChkSum = 0;
	int nCount=0, nBufSize=0, i;
	
	if(bysCmd == NULL || *pcbCmd == NULL)
		return FALSE;
	nBufSize = *pcbCmd;
	
	strCmd.MakeUpper(); //Make the command upper case
	
	for (i=0; i<nBufSize/2; i++)
	{
		strTemp = strCmd.Left(2);
		bysCmd[i] = Char2Hex(strTemp[0]) << 4 | Char2Hex(strTemp[1]);		
		strCmd = strCmd.Right(nBufSize-2*i-2);
		nCount++;
	}
	
	*pcbCmd = nCount;
	
	return TRUE; 
}

// Get the Hex byte for matching char
BYTE CKeyInjectModuleDlg::Char2Hex(char ch) 
{
	if( ch >= '0' && ch <= '9')
		return BYTE(ch-'0');
	
	if(ch >= 'A' && ch <= 'F')
		return BYTE(ch-'A'+10);
	
	if(ch >= 'a' && ch <= 'f')
		return BYTE(ch-'a'+10);
	
	return 0;
}

byte CKeyInjectModuleDlg::asctohex(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (16*m+n);
	
}

byte CKeyInjectModuleDlg::asctodec(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (10*m+n);
	
}

//function:  if you click this button, it will pop up a input dialog,
//           when you enter all parameter and click OK, then it will encrypt
//           the PIN block with the PIN pad device key in DUKPT.
//           the PIN block can be formated with PIN and account number that 
//           you entered.
void CKeyInjectModuleDlg::Decryption() 
{
	//unsigned long   counter;
	unsigned char  stringKSN[10];
	int bSessionIDLen;
	CString        message, strASCII, strHEX, strSessionID, strTmp;
	unsigned char  k=1;
	int i;	
	strASCII = _T("");
	strHEX = _T("");
	strSessionID = _T("");
	message = _T("");
		
	{

		//Initial key
		if (!bBDK)
		{
			m_str_BDK = StrBDK;
			int len = m_str_BDK.GetLength();

			for(i=0; i<len/2; i++)							
				m_nderivation_key[i] = asctohex(m_str_BDK.GetAt(2*i),m_str_BDK.GetAt(2*i+1));
		}

		memcpy(stringKSN, m_nksn,10);
		GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);
				
		//get the m_cryptoKey
		memset(m_cryptoKey, 0, 16);
		CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);
		
		
		if(m_CardType == 0){
			message = "Card Type: ISO/ABA\r\n";
		}else if (m_CardType == 1){
			message = "Card Type: AAMVA\r\n";
		}else if (m_CardType == 2){
			message = "Card Type: CADL\r\n";
		}else if (m_CardType == 3){
			message = "Card Type: Others\r\n";
		}
		
	
		if (EncodingType < 0x80) //old encryption format
		{
			// TDES Decryption
			if (bDecryptMode == 1)
			{
				unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};


				if (bTrk1)
				{	
					TDES_Decryption(m_TrackBuffer, m_cryptoKey, init_vector, DataLen);
					
					// Decrypted Data in ASCII format
					for(i = 0; i < (int) DataLen; i++)
					{
						strTmp.Format("%C", m_TrackBuffer[i]);
						strASCII += strTmp;
					}
				
					strASCII += "\r\n";
					// Decrypted Data in HEX format
					for(i = 0; i < (int) DataLen; i++)
					{
						strTmp.Format("%02X", m_TrackBuffer[i]);
						strHEX += strTmp;
					}
				}	
			}

			// AES Decryption
			else
			{
				unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};							
				
				if (bTrk1)
				{	
					AES_Decryption(m_TrackBuffer, m_cryptoKey, init_vector, DataLen);
					
					// Decrypted Data in ASCII format
					for(i = 0; i < (int) DataLen; i++)
					{
						strTmp.Format("%C", m_TrackBuffer[i]);
						strASCII += strTmp;
					}
				
					strASCII += "\r\n";
					// Decrypted Data in HEX format
					for(i = 0; i < (int) DataLen; i++)
					{
						strTmp.Format("%02X", m_TrackBuffer[i]);
						strHEX += strTmp;
					}
				}				
			}
			
			// Track 3 Card Data
			if (!KBMode) // USB HID
			{				
				if ((CardData[7]) && (EncodingType==0))
				{		
					for (i=CardData[5]+CardData[6]+8; i<CardData[5]+CardData[6]+CardData[7]+8; i++)
					{		
						strTmp.Format("%C",CardData[i]);
						strASCII+= strTmp;
					}
				}
			}					
			
			else	// USB KB
			{								
				if ((USBKB_Data[8]) && (EncodingType==0))
					strASCII += StrUSBKB.Mid(16+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);
				
				GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
				GetDlgItem(IDC_COMMAND)->SetFocus();				
			}
			
		
			// Session ID
			if (bActivation) 
			{	
				strSessionID += _T("\r\nSession ID: ");
				

				if (!KBMode) // USB HID
				{
					for(i = CardData[5]+CardData[6]; i < CardData[5]+CardData[6]+8; i++)
					{
						strTmp.Format("%02X ", m_TrackBuffer[i]);
						strSessionID += strTmp;
					}				
				}
				
				else	// USB KB			
				{
					for(i = USBKB_Data[6]+USBKB_Data[7]; i < USBKB_Data[6]+USBKB_Data[7]+8; i++)
					{
						strTmp.Format("%02X ", m_TrackBuffer[i]);
						strSessionID += strTmp;
					}
				}
			}

		}
		
	
		
		else // if (EncodingType >= 0x80)
		{
			// TDES Decryption
			if (bDecryptMode == 1)	
			{
				unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
				bSessionIDLen = 8;	
				
				if (bTrk1)
				{
					TDES_Decryption(m_Track1Buffer, m_cryptoKey, init_vector, DataLen1);
					
					// Decrypted Track 1 Data in ASCII format
					for(i = 0; i < (int) DataLen1; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Decrypted Track 1 Data in HEX format
					for(i = 0; i < (int) DataLen1; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk2)
				{	
					TDES_Decryption(m_Track2Buffer, m_cryptoKey, init_vector, DataLen2);
					
					// Decrypted Track 2 Data in ASCII format
					for(i = 0; i < (int) DataLen2; i++)
					{
						strTmp.Format("%C", m_Track2Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Decrypted Track 2 Data in HEX format
					for(i = 0; i < (int) DataLen2; i++)
					{
						strTmp.Format("%02X", m_Track2Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk3)
				{	
					TDES_Decryption(m_Track3Buffer, m_cryptoKey, init_vector, DataLen3);
					
					// Decrypted Track 3 Data in ASCII format
					for(i = 0; i < (int) DataLen3; i++)
					{
						strTmp.Format("%C", m_Track3Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Decrypted Track 3 Data in HEX format
					for(i = 0; i < (int) DataLen3; i++)
					{
						strTmp.Format("%02X", m_Track3Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}	


				// Session ID
				if (bActivation) 
				{	
					strSessionID = "\r\nSession ID: ";	
					TDES_Decryption(m_SessionIDBuffer, m_cryptoKey, init_vector, 8);
					
					// Decrypted Session ID
					for(i = 0; i < bSessionIDLen; i++)
					{
						strTmp.Format("%02X ", m_SessionIDBuffer[i]);
						strSessionID += strTmp;
					}
				}	
			}
					
				
				
			// AES Decryption
			else if (bDecryptMode == 2)					
			{
				unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};	
				bSessionIDLen = 16;	
						
				if (bTrk1)
				{	
					AES_Decryption(m_Track1Buffer, m_cryptoKey, init_vector, DataLen1);
					
					// Decrypted Track 1 Data in ASCII format
					for(i = 0; i < (int) DataLen1; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Decrypted Track 1 Data in HEX format
					for(i = 0; i < (int) DataLen1; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk2)
				{	
					AES_Decryption(m_Track2Buffer, m_cryptoKey, init_vector, DataLen2);
					
					// Decrypted Track 2 Data in ASCII format
					for(i = 0; i < (int) DataLen2; i++)
					{
						strTmp.Format("%C", m_Track2Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Decrypted Track 2 Data in HEX format
					for(i = 0; i < (int) DataLen2; i++)
					{
						strTmp.Format("%02X", m_Track2Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk3)
				{	
					AES_Decryption(m_Track3Buffer, m_cryptoKey, init_vector, DataLen3);
					
					// Decrypted Track 3 Data in ASCII format
					for(i = 0; i < (int) DataLen3; i++)
					{
						strTmp.Format("%C", m_Track3Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Decrypted Track 3 Data in HEX format
					for(i = 0; i < (int) DataLen3; i++)
					{
						strTmp.Format("%02X", m_Track3Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}	


				// Session ID
				if (bActivation) 
				{	
					strSessionID = "Session ID: ";
					AES_Decryption(m_SessionIDBuffer, m_cryptoKey, init_vector, 16);
					
					// Decrypted Session ID
					for(i = 0; i < bSessionIDLen; i++)
					{
						strTmp.Format("%02X ", m_SessionIDBuffer[i]);
						strSessionID += strTmp;
					}
				}
			}
		

			if (KBMode) // if USB KB, clear the Command Window for the next swipe
			{
				GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
				GetDlgItem(IDC_COMMAND)->SetFocus();
			}				
		
		}
		
		// Key
		strTmp.Format("Key Value: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
			m_cryptoKey[0],m_cryptoKey[1],m_cryptoKey[2], m_cryptoKey[3],m_cryptoKey[4],\
			m_cryptoKey[5], m_cryptoKey[6], m_cryptoKey[7],m_cryptoKey[8],m_cryptoKey[9],\
			m_cryptoKey[0x0a], m_cryptoKey[0x0b],m_cryptoKey[0x0c], \
			m_cryptoKey[0x0d], m_cryptoKey[0x0e], m_cryptoKey[0x0f]);
		
		message += strTmp;
		
		// KSN
		strTmp.Format("\r\nKSN: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
			glm_nksn[0],glm_nksn[1],glm_nksn[2], glm_nksn[3],glm_nksn[4],\
			glm_nksn[5], glm_nksn[6], glm_nksn[7],glm_nksn[8],glm_nksn[9]);
		
		message += strTmp;

		// Display Session ID
		if (bActivation)
			message += strSessionID;

		 
		message += "\r\n\r\nDecrypted Data:\r\n" + strASCII + "\r\n\r\n" + strHEX;
        ((CStatic *)GetDlgItem(IDC_RESP)) -> SetWindowText(message);
		
	}			
}

void CKeyInjectModuleDlg::Received_HID_Data() 
{
	bUpdateDisplay = true;
}


void CKeyInjectModuleDlg::OnTimer(UINT nIDEvent) 
{
	CheckReaderConnection();
	GetDlgItem(IDC_READER_STATUS)->SetWindowText(StrReaderStatus);
		
	if(bUpdateDisplay)
	{
		bUpdateDisplay = false;
		DisplayHID_Data();
		TimeoutCounter = 0;
	}
		
	else
		TimeoutCounter++;

	if(TimeoutCounter > 10)	
		StrHID_Data = _T("");

	
	CDialog::OnTimer(nIDEvent);

}

void CKeyInjectModuleDlg::DisplayHID_Data() 
{   
	GetDlgItem(IDC_COMMAND)->SetWindowText(StrHID_Data);	

}

void CKeyInjectModuleDlg::SetDecodeMode( int decode ) 
{
	if(decode == 0)	// ASCII
	{
		bHex = false;
		CheckRadioButton(IDC_DECODE_ASCII, IDC_DECODE_HEX, IDC_DECODE_ASCII);
	}
	else			// HEX
	{
		bHex = true;
		CheckRadioButton(IDC_DECODE_ASCII, IDC_DECODE_HEX, IDC_DECODE_HEX);
	}
}

void CKeyInjectModuleDlg::OnInputKey() 
{
	int i;

	m_KeyDlg.m_BDK = "";
	m_KeyDlg.DoModal();	
		
	if(m_KeyDlg.m_BDK.GetLength() <32)
	{
		MessageBox("Key Length is less than 16 byte (32 character) long!","Error");
		return;
	}

	for (i=0; i<32; i++)
		m_nderivation_key[i] = asctohex(m_KeyDlg.m_BDK.GetAt(2*i),m_KeyDlg.m_BDK.GetAt(2*i+1));
	
	bBDK = true;	
}

void CKeyInjectModuleDlg::OnSend() 
{
	int nSize,i;
	BOOL bRet=TRUE;
	BYTE CmdBuf[500], CmdBuf2[503], LRC = 0;
	CString		StrResponse, StrTmp;
	unsigned long RespLen = 3;
	
					
	//get command text
	GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
	
	StrCommand.Remove(_T(' ')); //remove space
	StrCommand.Remove(_T('\t')); //remove tab
	
	
	if(StrCommand.IsEmpty())  // Check if the command string is empty
	{
		MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
		return;
	}
	
	nSize = StrCommand.GetLength();
	
	// Convert the command to hex format
	bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
	
	if(bRet == FALSE)
	{
		MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
		return;
	}
	
	// Recomposite the whole command
	CmdBuf2[0] = 0x60;
	CmdBuf2[1] = nSize/256;
	CmdBuf2[2] = nSize%256;
	
	for(i=0; i<nSize; i++)
		CmdBuf2[i+3] = CmdBuf[i];
	
	for(i=0; i<nSize+3; i++)
		LRC ^= CmdBuf2[i];

	CmdBuf2[nSize+3] = LRC;

	CmdBuf2[nSize+4] = 3;			

	SendCommandRequest(CmdBuf2, nSize+5);
}

void CKeyInjectModuleDlg::OnDecrypt() 
{
	const TCHAR CR[] = {13, 0};
	BOOL bDecryption = false;

	unsigned char len = 0;
	unsigned char berror = 0;
	CString StringTmp, StrTmp;

	bTrk1 = bTrk2 = bTrk3 = false;

	int i;

	int EncryptedTrackLength = 0;
	int EncryptedTrack1Length = 0;
	int EncryptedTrack2Length = 0;
	int EncryptedTrack3Length = 0;
		
	int UnencryptedLength = 0;	
	int shiftSize = 0;

	int Data_Length;
	bool bETX = false;

	//DES type
	m_des_index = 1;

	if(!bDecryptMode)
		return;
		
	if (!KBMode) // USB HID
	{

		int Length, pos = -1;		
		BYTE TempLRC=0;
		BYTE TempCheckSum=0;
		CString StrTemp;
		GetDlgItem(IDC_COMMAND)->GetWindowText(StrCardData);
		
		do
		{
			// Filter out card notifications which start with 00 00 00 00 00 00 04 00 07
			pos = StrCardData.Find("000000000000040007");
			if (pos>=0)
			{
				if(pos<StrCardData.GetLength()/2)
					StrCardData = StrCardData.Right(StrCardData.GetLength()-pos-34);
				else			
					StrCardData = StrCardData.Left(pos);
			}
		}while(pos>=0);

		Data_Length = StrCardData.GetLength()/2 - 1;

		for (i=0; i<Data_Length; i++)
			CardData[i] = asctohex(StrCardData.GetAt(2*i),StrCardData.GetAt(2*i+1));


		if (!Data_Length)
		{
			//MessageBox("Zero Length!");
			return;
		}

		// Check Length
		if(bMOIR)	// MOIR Envelope		
		{
			Length = CardData[1]*256 + CardData[2];		
			
		    if ( Length != Data_Length-5)
			{
				StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, Data_Length-5);
				MessageBox(StrTemp);
			}
		}
		else		// NGA Envelope
		{
			Length = CardData[2]*256 + CardData[1];		
			
		    if ( Length != Data_Length-6)
			{
				StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, Data_Length-6);
				MessageBox(StrTemp);
			}
		}
		

		// LRC
		if(bMOIR)	// MOIR Envelope		
		{
			for (i=0; i<Data_Length-2; i++)
				TempLRC ^= CardData[i];

			StrTemp.Format("LRC error!\r\nLRC from Data: %04X\r\nCalculated LRC: %04X",CardData[Data_Length-2], TempLRC);
			
			if (TempLRC != CardData[Data_Length-2])
				MessageBox(StrTemp);
		}
		
		else		// NGA Envelope
		{
			for (i=3; i<Data_Length-3; i++)
				TempLRC ^= CardData[i];

			StrTemp.Format("LRC error!\r\nLRC from Data: %04X\r\nCalculated LRC: %04X",CardData[Data_Length-3], TempLRC);
			
			if (TempLRC != CardData[Data_Length-3])
				MessageBox(StrTemp);
		}

	
		// CheckSum
		if(!bMOIR)	// NGA Envelope		
		{			
			for (i=3; i<Data_Length-3; i++)
				TempCheckSum += CardData[i];
			
			StrTemp.Format("CheckSum error!\r\nCheckSum from Data: %04X\r\nCalculated CheckSum: %04X",CardData[Data_Length-2], TempCheckSum);

			if (TempCheckSum != CardData[Data_Length-2])
				MessageBox(StrTemp);
		}


		EncodingType = CardData[3];


	
		if (EncodingType < 0x80)
		{
		
			// Non ISO/ABA Data Output Format and Non raw
			if ((CardData[3] != 0) && (CardData[3] != 4)) // 1:AAMVA, 3:Others
			{
				StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";
				for (i=0; i<Data_Length; i++)
				{		
					StringTmp.Format("%02X",CardData[i]);
					StrTmp += StringTmp;
				}

						
				StrTmp += "\r\n\r\nCard Data:\r\n";
				if (CardData[5])
				{				
					for (i=0; i<CardData[5]; i++)
					{		
						StringTmp.Format("%C",CardData[i+8]);
						StrTmp += StringTmp;
					}
				}

				if (CardData[6])
				{				
					for (i=CardData[5]+8; i<CardData[5]+CardData[6]+8; i++)
					{		
						StringTmp.Format("%C",CardData[i]);
						StrTmp += StringTmp;
					}
				}

				if (CardData[7])
				{				
					for (i=CardData[5]+CardData[6]+8; i<CardData[5]+CardData[6]+CardData[7]+8; i++)
					{		
						StringTmp.Format("%C",CardData[i]);
						StrTmp += StringTmp;
					}
				}
		 
				GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
			}

			// ISO/ABA Data Output Format or Raw Format
			else // if ((CardData[3] == 0) || (CardData[3] == 4))
			{
				if (CardData[3] == 0)
					StrTmp = "Reader Output: (ISO/ABA Data Output Format)\r\n";
				else
					StrTmp = "Reader Output: (Encrypted ID Tech Raw Data Output Format)\r\n";


				if(bMOIR)	// MOIR Envelope
				{
					for (i=0; i<10; i++)
						glm_nksn[i] = CardData[i+Data_Length-12];
				}

				else		// NGA Envelope
				{
					for (i=0; i<10; i++)
						glm_nksn[i] = CardData[i+Data_Length-13];
				}



				for (i=0; i<Data_Length; i++)
				{		
					StringTmp.Format("%02X",CardData[i]);
					StrTmp += StringTmp;
				}


				if (CardData[3] == 0)
				{
					StrTmp += "\r\n\r\nMasked Data: ";
					if (CardData[5])
					{	
						StrTmp += "\r\nTrack 1: ";
						for (i=0; i<CardData[5]; i++)
						{		
							StringTmp.Format("%C",CardData[i+8]);
							StrTmp += StringTmp;
						}
					}

					if (CardData[6])
					{
						StrTmp += "\r\nTrack 2: ";
						for (i=CardData[5]+8; i<CardData[5]+CardData[6]+8; i++)
						{		
							StringTmp.Format("%C",CardData[i]);
							StrTmp += StringTmp;
						}
					}

					if (CardData[7])
					{
						StrTmp += "\r\nTrack 3: ";
						for (i=CardData[5]+CardData[6]+8; i<CardData[5]+CardData[6]+CardData[7]+8; i++)
						{		
							StringTmp.Format("%C",CardData[i]);
							StrTmp += StringTmp;
						}
					}

					UnencryptedLength = CardData[5]+CardData[6]+CardData[7];
					

					if (bActivation) // Security Level = 4
					{
						if (bDecryptMode == 1) // TDES
						{
							if (((CardData[5]+CardData[6]+8)%8) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6]+8;
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6]+8)/8 + 1)*8; 
						}

						else if (bDecryptMode == 2) // AES
						{
							if (((CardData[5]+CardData[6]+8)%16) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6]+8;
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6]+8)/16 + 1)*16; 			
						}
					}

					else	
					{
						if (bDecryptMode == 1) // TDES
						{
							if (((CardData[5]+CardData[6])%8) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6];
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6])/8 + 1)*8; 
						}

						else if (bDecryptMode == 2) // AES
						{
							if (((CardData[5]+CardData[6])%16) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6];
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6])/16 + 1)*16; 			
						}
					}

					DataLen = EncryptedTrackLength;
			
					for (i = 0; i<EncryptedTrackLength; i++)
						m_TrackBuffer[i] = CardData[i+UnencryptedLength+8];
					
				}

				else // ID Tech Encrypted Raw Data
				{
					StrTmp += "\r\n\r\nEncrypted ID Tech Raw Data:\r\n";

							
					if (bDecryptMode == 1) // TDES
					{					
						if(CardData[3]==4) //ID Tech Format Raw Data
						{
							if (((CardData[5]+CardData[6]+CardData[7]+8)%8) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6]+CardData[7];
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6]+CardData[7]+8)/8 + 1)*8; 
						}

						else
						{
							if (((CardData[5]+CardData[6]+CardData[7])%8) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6]+CardData[7];
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6]+CardData[7])/8 + 1)*8; 
						}
					}

					else if (bDecryptMode == 2) // AES
					{
						if(CardData[3]==4) //ID Tech Format Raw Data
						{
							if (((CardData[5]+CardData[6]+CardData[7]+8)%16) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6]+CardData[7];
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6]+CardData[7]+8)/16 + 1)*16; 			
						}

						else
						{
							if (((CardData[5]+CardData[6]+CardData[7])%16) == 0)
								EncryptedTrackLength = CardData[5]+CardData[6]+CardData[7];
							else
								EncryptedTrackLength = ((CardData[5]+CardData[6]+CardData[7])/16 + 1)*16; 			
						}
					}

					DataLen = EncryptedTrackLength;
				
					for (i = 0; i<EncryptedTrackLength; i++)
					{
						m_TrackBuffer[i] = CardData[i+8];
						StringTmp.Format("%02X",CardData[i+8]);
						StrTmp += StringTmp;
					}
				}


				bTrk1 = true;
				bDecryption = true;	

				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);

				for(i=0; i<10; i++)	
					m_nksn[i] = glm_nksn[i];			
			
				Decryption();
			}		

		}


		else if (EncodingType != 0x84)  // Type = 0x80 or 0x81 or 0x83
		{

			// Non ISO/ABA Data Output Format
			if ((EncodingType == 0x81) || (EncodingType == 0x83))				
				StrTmp = "Reader Output: (Non ISO/ABA Enhanced Data Output Format)\r\n";
						
							
			// ISO/ABA Data Output Format
			else if (EncodingType == 0x80)	
				StrTmp += "Reader Output: (ISO/ABA Enhanced Data Output Format)";


			if(bMOIR)	// MOIR Envelope
			{
				for (i=0; i<10; i++)
					glm_nksn[i] = CardData[i+Data_Length-12];
			}

			else		// NGA Envelope
			{
				for (i=0; i<10; i++)
					glm_nksn[i] = CardData[i+Data_Length-13];
			}
			
			
			for (i=0; i<Data_Length; i++)
			{		
				StringTmp.Format("%02X",CardData[i]);
				StrTmp += StringTmp;
			}
				

			/*
				Clear/mask data sent status byte:
				bit 0: 1--- if TK1 clear/mask data present 
				bit 1: 1--- if TK2 clear/mask data present
				bit 2: 1--- if TK3 clear/mask data present
				Bit 3:0-0
				Bit 4:0-0
				Bit 5:0-0
			*/
			BYTE bClearMaskDataStatus = CardData[8];

			/*
				Encrypted data sent status
				bit 0: if 1-tk1 encrypted data present 
				bit 1: if 1-tk2 encrypted data present
				bit 2: if 1-tk3 encrypted data present
				bit 3: if 1-tk1 hash data present
				bit 4: if 1-tk2 hash data present
				bit 5: if 1-tk3 hash data present
				Bit 6: if 1-session ID present 
				Bit 7: if 1-KSN present
			*/
			BYTE bEncryptedDataStatus = CardData[9];	
			

			if (bClearMaskDataStatus)
				StrTmp += "\r\n\r\nClear/Masked Data: ";
			
			if (CardData[5])
			{
				if (bClearMaskDataStatus & 1)
				{	
					StrTmp += "\r\nTrack 1: ";
					
					for (i=0; i<CardData[5]; i++)
					{		
						StringTmp.Format("%C",CardData[i+10]);
						StrTmp += StringTmp;
					}

					UnencryptedLength += CardData[5];
				}

				if (bEncryptedDataStatus & 1)
				{
					bTrk1 = true;
					if (bDecryptMode == 1) // TDES
					{
						if ((CardData[5] % 8) == 0)
							EncryptedTrack1Length = CardData[5];
						else
							EncryptedTrack1Length = (CardData[5] / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if ((CardData[5] % 16) == 0)
							EncryptedTrack1Length = CardData[5];
						else
							EncryptedTrack1Length = (CardData[5] / 16 + 1) * 16;
					}					

					DataLen1 = EncryptedTrack1Length;
				}
				
			}
					
						
			if (CardData[6])
			{		
				if (bClearMaskDataStatus & 2)
				{
					StrTmp += "\r\nTrack 2: ";
					
					for (i=UnencryptedLength+10; i<UnencryptedLength+CardData[6]+10; i++)
					{		
						StringTmp.Format("%C",CardData[i]);
						StrTmp += StringTmp;
					}
					UnencryptedLength += CardData[6];
				}

				if (bEncryptedDataStatus & 2)
				{
					bTrk2 = true;
					if (bDecryptMode == 1) // TDES
					{
						if ((CardData[6] % 8) == 0)
							EncryptedTrack2Length = CardData[6];
						else
							EncryptedTrack2Length = (CardData[6] / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if ((CardData[6] % 16) == 0)
							EncryptedTrack2Length = CardData[6];
						else
							EncryptedTrack2Length = (CardData[6] / 16 + 1) * 16;
					}
	

					DataLen2 = EncryptedTrack2Length;
				}						
			}
				
					
			if (CardData[7])
			{
				

				if (bClearMaskDataStatus & 4)
				{
					StrTmp += "\r\nTrack 3: ";
					
					for (i=UnencryptedLength+10; i<UnencryptedLength+CardData[7]+10; i++)
					{		
						StringTmp.Format("%C",CardData[i]);
						StrTmp += StringTmp;
					}
					UnencryptedLength += CardData[7];
					
				}

				if (bEncryptedDataStatus & 4)
				{

					bTrk3 = true;
					if (bDecryptMode == 1) // TDES
					{
						if ((CardData[7] % 8) == 0)
							EncryptedTrack3Length = CardData[7];
						else
							EncryptedTrack3Length = (CardData[7] / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if ((CardData[7] % 16) == 0)
							EncryptedTrack3Length = CardData[7];
						else
							EncryptedTrack3Length = (CardData[7] / 16 + 1) * 16;
					}				

					DataLen3 = EncryptedTrack3Length;
				}
			}

			if ((bTrk1)||(bTrk2)||(bTrk3))
			{
				if(bTrk1)
					for (i = 0; i<EncryptedTrack1Length; i++)
						m_Track1Buffer[i] = CardData[i+UnencryptedLength+10];

				if(bTrk2)
					for (i = 0; i<EncryptedTrack2Length; i++)
						m_Track2Buffer[i] = CardData[i+UnencryptedLength+EncryptedTrack1Length+10];

				if(bTrk3)
					for (i = 0; i<EncryptedTrack3Length; i++)
						m_Track3Buffer[i] = CardData[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+10];


				// Security Level=4
				if ((bActivation) && (bEncryptedDataStatus & 64)) // Check if passed the activation and the data contains SessionID
				{	
					if (bDecryptMode == 1) // TDES
					{
						for (i = 0; i<8; i++)
							m_SessionIDBuffer[i] = CardData[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+10];
					}
					
					else if (bDecryptMode == 2) // AES
					{
						for (i = 0; i<16; i++)
							m_SessionIDBuffer[i] = CardData[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+10];
					}
				}
						

				
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
				
				
				for(i=0; i<10; i++)	
					m_nksn[i] = glm_nksn[i];			
				
				
				Decryption();
			}
				
			else
			{
			
				GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);				
				
			}
		}

		// Raw Data Output Format
		else //if (EncodingType == 0x84)				
		{
			StrTmp += "Reader Output: (Raw Data Enhanced Output Format)";						
			
			if(bMOIR)	// MOIR Envelope
			{
				for (i=0; i<10; i++)
					glm_nksn[i] = CardData[i+Data_Length-12];
			}

			else		// NGA Envelope
			{
				for (i=0; i<10; i++)
					glm_nksn[i] = CardData[i+Data_Length-13];
			}
			
			for (i=0; i<Data_Length; i++)
			{		
				StringTmp.Format("%02X",CardData[i]);
				StrTmp += StringTmp;
			}
			
		
			if (CardData[5])
			{
				bTrk1 = true;
			
				if (bDecryptMode == 1) // TDES
				{
					if ((CardData[5] % 8) == 0)
						EncryptedTrack1Length = CardData[5];
					else
						EncryptedTrack1Length = (CardData[5]/ 8 + 1) * 8;
				}
				
				else if (bDecryptMode == 2) // AES
				{
					if ((CardData[5] % 16) == 0)
						EncryptedTrack1Length = CardData[5];
					else
						EncryptedTrack1Length = (CardData[5] / 16 + 1) * 16;
				}
				
				for (i = 0; i<EncryptedTrack1Length; i++)
					m_Track1Buffer[i] = CardData[i+10];

				DataLen1 = EncryptedTrack1Length;
				
			}
			
				
			if (CardData[6])
			{
				bTrk2 = true;
			
				if (bDecryptMode == 1) // TDES
				{
					if ((CardData[6] % 8) == 0)
						EncryptedTrack2Length = CardData[6];
					else
						EncryptedTrack2Length = (CardData[6] / 8 + 1) * 8;
				}
				
				else if (bDecryptMode == 2) // AES
				{
					if ((CardData[6] % 16) == 0)
						EncryptedTrack2Length = CardData[6];
					else
						EncryptedTrack2Length = (CardData[6] / 16 + 1) * 16;
				}

				for (i = 0; i<EncryptedTrack2Length; i++)
					m_Track2Buffer[i] = CardData[i+EncryptedTrack1Length+10];

				DataLen2 = EncryptedTrack2Length;
				
			}
			
				
			if (CardData[7])
			{
				bTrk3 = true;
			
				if (bDecryptMode == 1) // TDES
				{
					if ((CardData[7] % 8) == 0)
						EncryptedTrack3Length = CardData[7];
					else
						EncryptedTrack3Length = (CardData[7] / 8 + 1) * 8;
				}
				
				else if (bDecryptMode == 2) // AES
				{
					if ((CardData[7] % 16) == 0)
						EncryptedTrack3Length = CardData[7];
					else
						EncryptedTrack3Length = (CardData[7] / 16 + 1) * 16;
				}

				for (i = 0; i<EncryptedTrack3Length; i++)
					m_Track3Buffer[i] = CardData[i+EncryptedTrack1Length+EncryptedTrack2Length+10];

				DataLen3 = EncryptedTrack3Length;
			}


			// Security Level=4
			if (bActivation)
			{	
				if (bDecryptMode == 1) // TDES
				{
					for (i = 0; i<8; i++)
						m_SessionIDBuffer[i] = CardData[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
				}
				
				else if (bDecryptMode == 2) // AES
				{
					for (i = 0; i<16; i++)
						m_SessionIDBuffer[i] = CardData[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
				}
			}
	
			/*
				Encrypted data sent status
				bit 0: if 1-tk1 encrypted data present 
				bit 1: if 1-tk2 encrypted data present
				bit 2: if 1-tk3 encrypted data present
				bit 3: if 1-tk1 hash data present
				bit 4: if 1-tk2 hash data present
				bit 5: if 1-tk3 hash data present
				Bit 6: if 1-session ID present 
				Bit 7: if 1-KSN present
			*/
			BYTE bEncryptedDataStatus = CardData[9];		
	
			
			GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			
			
			for(i=0; i<10; i++)	
				m_nksn[i] = glm_nksn[i];			
			
			Decryption();
			
		}
	
			
	}
	
	else	// USB KB
	{
		
		GetDlgItem(IDC_COMMAND)->GetWindowText(StrUSBKB);
		USBKB_Data_Length = StrUSBKB.GetLength();
		
		if (USBKB_Data_Length > 0)
		{		
			
			int Length;
			BYTE TempData[1000];
			BYTE TempLRC=0;
			BYTE TempCheckSum=0;
			CString StrTemp;
			CString Str_1st, Str_2nd;
			int StartPos, EndPos1, EndPos2;
			

			Str_1st = StrUSBKB.Left(USBKB_Data_Length/2);
			Str_2nd = StrUSBKB.Right(USBKB_Data_Length/2 + USBKB_Data_Length%2);


			if(bMOIR)
			{
				// Filter out notification before card data			
				StartPos = Str_1st.Find("60");
				Str_1st = Str_1st.Right(Str_1st.GetLength()-StartPos);	
			}

			else // NGA Protocol
			{
				// Filter out notification before card data			
				StartPos = Str_1st.Find("02");
				Str_1st = Str_1st.Right(Str_1st.GetLength()-StartPos);	
				
			}
		
			do
			{
				// Filter out notification after card data
				EndPos1 = Str_2nd.ReverseFind('3');
				EndPos2 = Str_2nd.ReverseFind('0');

				if (EndPos1 == EndPos2+1)
				{
					Str_2nd = Str_2nd.Left(EndPos1+1);				
					bETX = true;
				}
				else
					Str_2nd = Str_2nd.Left(EndPos1);

				if((EndPos1 < 0) || (EndPos2 < 0))
					break;

			}while(!bETX);
	
					
			// Rebuild the output string without notification 
			StrUSBKB = Str_1st + Str_2nd;
			USBKB_Data_Length = StrUSBKB.GetLength();

	
			for (i=0; i<10; i++)
				USBKB_Data[i+1] = asctohex(StrUSBKB.GetAt(2*i),StrUSBKB.GetAt(2*i+1));


			for (i=0; i<USBKB_Data_Length; i++)
				TempData[i] = StrUSBKB.GetAt(i);


			if(bMOIR)
			{
				// Check Length
				Length = USBKB_Data[2]*256 + USBKB_Data[3];	
				StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, USBKB_Data_Length-10);
				if ( Length != USBKB_Data_Length-10)
					MessageBox(StrTemp);

				// LRC
				TempLRC = 0;
				for (i=0; i<USBKB_Data_Length-4; i++)
					TempLRC ^= TempData[i];

				StrTemp.Format("LRC error!\r\nLRC from Data: %02X\r\nCalculated LRC: %02X",asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)), TempLRC);
				
				if (TempLRC != asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)))
					MessageBox(StrTemp);

			
			}
		
			else
			{
				Length = USBKB_Data[3]*256 + USBKB_Data[2];	
				StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, USBKB_Data_Length-12);
	
				if ( Length != USBKB_Data_Length-12)
					MessageBox(StrTemp);


				// LRC
				TempLRC = 0;
				for (i=6; i<USBKB_Data_Length-6; i++)
					TempLRC ^= TempData[i];

				StrTemp.Format("LRC error!\r\nLRC from Data: %02X\r\nCalculated LRC: %02X",asctohex(StrUSBKB.GetAt(USBKB_Data_Length-6),StrUSBKB.GetAt(USBKB_Data_Length-5)), TempLRC);
				
				if (TempLRC != asctohex(StrUSBKB.GetAt(USBKB_Data_Length-6),StrUSBKB.GetAt(USBKB_Data_Length-5)))
					MessageBox(StrTemp);


				// CheckSum
				for (i=6; i<USBKB_Data_Length-6; i++)
					TempCheckSum += TempData[i];
				
				StrTemp.Format("CheckSum error!\r\nCheckSum from Data: %02X\r\nCalculated CheckSum: %02X",asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)), TempCheckSum);

				if (TempCheckSum != asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)))
					MessageBox(StrTemp);				

			}


			EncodingType = USBKB_Data[4];

			if (EncodingType < 0x80)
			{
				// Non ISO/ABA Data Output Format
				if ((EncodingType == 1) || (EncodingType == 3))
				{
					StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";																
					
					if (USBKB_Data[6])										
						StrTmp += StrUSBKB.Mid(16,USBKB_Data[6]);						
					
					if (USBKB_Data[7])
						StrTmp += StrUSBKB.Mid(16+USBKB_Data[6],USBKB_Data[7]);						
						
					if (USBKB_Data[8])
						StrTmp += StrUSBKB.Mid(16+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);		
															
													
					GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
					GetDlgItem(IDC_COMMAND) -> SetWindowText("");
					GetDlgItem(IDC_COMMAND) -> SetFocus();			
				
				}
		
				// ISO/ABA Data Output Format
				else if (EncodingType == 0)				
				{			
					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
						
					if (bDecryptMode == 1) // TDES
					{
						if (((USBKB_Data[6]+USBKB_Data[7]+shiftSize)%8) == 0)
							EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+shiftSize)/8 + 1)*8; 
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if (((USBKB_Data[6]+USBKB_Data[7]+shiftSize)%16) == 0)
							EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+shiftSize)/16 + 1)*16; 
						
					}
					
					DataLen = EncryptedTrackLength;

					UnencryptedLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8];
					
					for (i = 0; i<EncryptedTrackLength; i++)
						m_TrackBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+16+2*i),StrUSBKB.GetAt(UnencryptedLength+17+2*i));
					
					
					if(bMOIR)	// MOIR Envelope
					{
						for (i=0; i<10; i++)
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-24+2*i),StrUSBKB.GetAt(USBKB_Data_Length-23+2*i));
					}

					else		// NGA Envelope
					{
						for (i=0; i<10; i++)
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
					}					
								
					bTrk1 = true;
					bDecryption = true;	
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					Decryption();
					
				}


				// Raw Data Output Format
				else if (EncodingType == 4)				
				{			
					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
						
					if (bDecryptMode == 1) // TDES
					{
						if (((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)%8) == 0)
							EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)/8 + 1)*8; 
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if (((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)%16) == 0)
							EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)/16 + 1)*16; 
						
					}
					
					DataLen = EncryptedTrackLength;
					
					for (i = 0; i<EncryptedTrackLength; i++)
						m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(16+2*i),StrUSBKB.GetAt(17+2*i));
					
					
					if(bMOIR)	// MOIR Envelope
					{
						for (i=0; i<10; i++)
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-24+2*i),StrUSBKB.GetAt(USBKB_Data_Length-23+2*i));
					}

					else		// NGA Envelope
					{
						for (i=0; i<10; i++)
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
					}						
								
					bTrk1 = true;
					bDecryption = true;	
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
			
					Decryption();
					
				}
			}


			else if (EncodingType != 0x84)  // Type = 0x80 or 0x81 or 0x83
			{

				// Non ISO/ABA Data Output Format
				if ((EncodingType == 0x81) || (EncodingType == 0x83))				
					StrTmp = "Reader Output: (Non ISO/ABA Enhanced Data Output Format)\r\n";
							
								
				// ISO/ABA Data Output Format
				else if (EncodingType == 0x80)	
					StrTmp += "Reader Output: (ISO/ABA Enhanced Data Output Format)\r\n";


				/*
					Clear/mask data sent status byte:
					bit 0: 1--- if TK1 clear/mask data present 
					bit 1: 1--- if TK2 clear/mask data present
					bit 2: 1--- if TK3 clear/mask data present
					Bit 3:0-0
					Bit 4:0-0
					Bit 5:0-0
				*/
				BYTE bClearMaskDataStatus = USBKB_Data[9];


				/*
					Encrypted data sent status
					bit 0: if 1-tk1 encrypted data present 
					bit 1: if 1-tk2 encrypted data present
					bit 2: if 1-tk3 encrypted data present
					bit 3: if 1-tk1 hash data present
					bit 4: if 1-tk2 hash data present
					bit 5: if 1-tk3 hash data present
					Bit 6: if 1-session ID present 
					Bit 7: if 1-KSN present
				*/
				BYTE bEncryptedDataStatus = USBKB_Data[10];	
			

				if (bClearMaskDataStatus)
					StrTmp += "\r\nClear/Masked Data: ";
			
					
				if (USBKB_Data[6])
				{
					if (bClearMaskDataStatus & 1)
					{	
						StrTmp += "\r\nTrack 1: ";
						
						if (USBKB_Data[6])										
								StrTmp += StrUSBKB.Mid(20,USBKB_Data[6]);	

						UnencryptedLength += USBKB_Data[6];
					}

					if (bEncryptedDataStatus & 1)
					{
						bTrk1 = true;
						if (bDecryptMode == 1) // TDES
						{
							if ((USBKB_Data[6] % 8) == 0)
								EncryptedTrack1Length = USBKB_Data[6];
							else
								EncryptedTrack1Length = (USBKB_Data[6] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((USBKB_Data[6] % 16) == 0)
								EncryptedTrack1Length = USBKB_Data[6];
							else
								EncryptedTrack1Length = (USBKB_Data[6] / 16 + 1) * 16;
						}					

						DataLen1 = EncryptedTrack1Length;
					}
					
				}
				

				if (USBKB_Data[7])
				{
					if (bClearMaskDataStatus & 2)
					{	
						StrTmp += "\r\nTrack 2: ";
						
						if (USBKB_Data[7])
							StrTmp += StrUSBKB.Mid(20+USBKB_Data[6],USBKB_Data[7]);						
								
						UnencryptedLength += USBKB_Data[7];
					}

					if (bEncryptedDataStatus & 2)
					{
						bTrk2 = true;
						if (bDecryptMode == 1) // TDES
						{
							if ((USBKB_Data[7] % 8) == 0)
								EncryptedTrack2Length = USBKB_Data[7];
							else
								EncryptedTrack2Length = (USBKB_Data[7] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((USBKB_Data[7] % 16) == 0)
								EncryptedTrack2Length = USBKB_Data[7];
							else
								EncryptedTrack2Length = (USBKB_Data[7] / 16 + 1) * 16;
						}					

						DataLen2 = EncryptedTrack2Length;
					}
					
				}
					
		
				if (USBKB_Data[8])
				{
					if (bClearMaskDataStatus & 4)
					{	
						StrTmp += "\r\nTrack 3: ";
						
						if (USBKB_Data[8])
							StrTmp += StrUSBKB.Mid(20+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);								
								
						UnencryptedLength += USBKB_Data[8];
					}

					if (bEncryptedDataStatus & 4)
					{
						bTrk3 = true;
						if (bDecryptMode == 1) // TDES
						{
							if ((USBKB_Data[8] % 8) == 0)
								EncryptedTrack3Length = USBKB_Data[8];
							else
								EncryptedTrack3Length = (USBKB_Data[8] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((USBKB_Data[7] % 16) == 0)
								EncryptedTrack3Length = USBKB_Data[8];
							else
								EncryptedTrack3Length = (USBKB_Data[8] / 16 + 1) * 16;
						}					

						DataLen3 = EncryptedTrack3Length;
					}
					
				}					
						
				

				if(bTrk1||bTrk2||bTrk3)
				{
					if (bTrk1)
						for (i = 0; i<EncryptedTrack1Length; i++)
							m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+20+2*i),StrUSBKB.GetAt(UnencryptedLength+21+2*i));

					if (bTrk2)
						for (i = 0; i<EncryptedTrack2Length; i++)
							m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+21+2*i));

					
					if (bTrk3)
						for (i = 0; i<EncryptedTrack3Length; i++)
							m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+21+2*i));

						
						
					// Security Level=4
					if (bActivation)
					{	
						if (bDecryptMode == 1) // TDES
						{
							for (i = 0; i<8; i++)
								m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
						}
						
						else if (bDecryptMode == 2) // AES
						{
							for (i = 0; i<16; i++)
								m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
						}
					}
						
					
					if(bMOIR)	// MOIR Envelope
					{
						for (i=0; i<10; i++)
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-24+2*i),StrUSBKB.GetAt(USBKB_Data_Length-23+2*i));
					}

					else		// NGA Envelope
					{
						for (i=0; i<10; i++)
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
					}						
						
					bDecryption = true;	
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					
					Decryption();
					
				}

				else // No encrypted data, display the clear text track data
				{			
					GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);										
					GetDlgItem(IDC_COMMAND) -> SetWindowText("");
					GetDlgItem(IDC_COMMAND) -> SetFocus();	
				
				}
			}


			// Raw Data Output Format
			else if (EncodingType == 0x84)				
			{	

				if (USBKB_Data[6])
				{
					bTrk1 = true;													

					if (bDecryptMode == 1) // TDES
					{
						if ((USBKB_Data[6] % 8) == 0)
							EncryptedTrack1Length = USBKB_Data[6];
						else
							EncryptedTrack1Length = (USBKB_Data[6] / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if ((USBKB_Data[6] % 16) == 0)
							EncryptedTrack1Length = USBKB_Data[6];
						else
							EncryptedTrack1Length = (USBKB_Data[6] / 16 + 1) * 16;
					}
					
					for (i = 0; i<EncryptedTrack1Length; i++)
						m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(20+2*i),StrUSBKB.GetAt(21+2*i));
						
					DataLen1 = EncryptedTrack1Length;
					
				}
				
					
				if (USBKB_Data[7])
				{
					bTrk2 = true;
					
					if (bDecryptMode == 1) // TDES
					{
						if ((USBKB_Data[7] % 8) == 0)
							EncryptedTrack2Length = USBKB_Data[7];
						else
							EncryptedTrack2Length = (USBKB_Data[7] / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if ((USBKB_Data[7] % 16) == 0)
							EncryptedTrack2Length = USBKB_Data[7];
						else
							EncryptedTrack2Length = (USBKB_Data[7] / 16 + 1) * 16;
					}

					for (i = 0; i<EncryptedTrack2Length; i++)
						m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+21+2*i));

					DataLen2 = EncryptedTrack2Length;
					
				}
				
					
				if (USBKB_Data[8])
				{
					bTrk3 = true;
					
					if (bDecryptMode == 1) // TDES
					{
						if ((USBKB_Data[8] % 8) == 0)
							EncryptedTrack3Length = USBKB_Data[8];
						else
							EncryptedTrack3Length = (USBKB_Data[8] / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if ((USBKB_Data[8] % 16) == 0)
							EncryptedTrack3Length = USBKB_Data[8];
						else
							EncryptedTrack3Length = (USBKB_Data[8] / 16 + 1) * 16;
					}

					for (i = 0; i<EncryptedTrack3Length; i++)
						m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+21+2*i));

					DataLen3 = EncryptedTrack3Length;
				}

				// Security Level=4
				if (bActivation)
				{	
					if (bDecryptMode == 1) // TDES
					{
						for (i = 0; i<8; i++)
							m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
					}
					
					else if (bDecryptMode == 2) // AES
					{
						for (i = 0; i<16; i++)
							m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
					}
				}
				
						
				if(bMOIR)	// MOIR Envelope
				{
					for (i=0; i<10; i++)
						glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-24+2*i),StrUSBKB.GetAt(USBKB_Data_Length-23+2*i));
				}

				else		// NGA Envelope
				{
					for (i=0; i<10; i++)
						glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
				}						
			
				bDecryption = true;	
				
				for(i=0; i<10; i++)	
					m_nksn[i] = glm_nksn[i];			
				
							
				Decryption();
				
			}
												
		}		
	}
}

void CKeyInjectModuleDlg::OnExit() 
{
	CDialog::OnCancel();
}

void CKeyInjectModuleDlg::OnMenuUsbkbMode() 
{
	const int outLength = 9;
	BYTE LRC = 0;
	BYTE datapool[outLength];

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x23;
	datapool[5] = 0x01;
	datapool[6] = 0x38;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;	

	SendCommandRequest(datapool, outLength);

	KBMode = 1; // USB KB		

}

void CKeyInjectModuleDlg::OnMenuHidMode() 
{
	const int outLength = 9;
	BYTE LRC = 0;
	BYTE datapool[outLength];

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x23;
	datapool[5] = 0x01;
	datapool[6] = 0x30;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;	

	SendCommandRequest(datapool, outLength);

	KBMode = 0; // USB HID		
}


void CKeyInjectModuleDlg::CheckReaderConnection() 
{
	bool bConnected = false;

	BYTE BufferTmp1[50], BufferTmp2[50];
	BYTE LRC = 0;
	ULONG	BufferLength1 = 50, BufferLength2 = 50;
		
	INTERFACE_TYPE emMyItfType; 
	ULONG emMyItfType1; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName;
	int		i, m_ulDevIndex = 0;
	
	emMyItfType1 = '1';
	emMyItfType2 = ITF_TYPE_USB_HID;


	CMSRItfUSBHID	MSR(emMyItfType2);
	for(m_ulDevIndex = 0; m_ulDevIndex < 30; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)			
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{					
					KBMode = 0; // USB HID					
					bConnected = true;					

					if (!bChecked)
					{

						if (nReader == 0)
							StrReaderStatus = _T("MOIR USB HID Connected ");

						else if (nReader == 1)
							StrReaderStatus = _T("MOIR USB HID (Other Format) Connected ");

						else if (nReader == 3)
							StrReaderStatus = _T("Secure MOIR USB HID Connected ");

						else if (nReader == 4)
							StrReaderStatus = _T("Secure MOIR USB HID (Other Format) Connected ");

						if ((nReader == 3) || (nReader == 4))
						{						
							const int outLength = 7;
							BYTE datapool[outLength];

							datapool[0] = 0x60;
							datapool[1] = 0;
							datapool[2] = 2;
							datapool[3] = 0x52;
							datapool[4] = 0x7E;
							
							for(i=0; i<5; i++)
								LRC ^= datapool[i];

							datapool[5] = LRC;

							datapool[6] = 3;	

							MSR.SendCommand_MOIR(datapool, outLength, BufferTmp1, &BufferLength1);
								
							if(BufferLength1)
							{
								if (BufferTmp1[5] < 0x33)	// Encryption is off
								{
									bDecryptMode = 0;
									SetDecodeMode(0);
									StrReaderStatus += _T(" ( No Encryption )");
								}

								else						// Encryption is on
								{
									// Check Encryption Method
									datapool[0] = 0x60;
									datapool[1] = 0;
									datapool[2] = 2;
									datapool[3] = 0x52;
									datapool[4] = 0x4C;
									
									LRC = 0;
									for(i=0; i<5; i++)
										LRC ^= datapool[i];

									datapool[5] = LRC;

									datapool[6] = 3;	
									MSR.SendCommand_MOIR(datapool, outLength, BufferTmp2, &BufferLength2);

									if(BufferLength2)
									{
										if (BufferTmp2[5] == 0x31)			// TDES
										{
											bDecryptMode = 1;
											StrReaderStatus += _T(" (TDES Encryption Enabled ");

											CheckMenuItem(m_menu, ID_MENU_TDES,MF_BYCOMMAND | MF_CHECKED); 
											CheckMenuItem(m_menu, ID_MENU_AES,MF_BYCOMMAND | MF_UNCHECKED); 
										}

										else if ( BufferTmp2[5] == 0x32)	// AES
										{
											bDecryptMode = 2;
											StrReaderStatus += _T(" (AES Encryption Enabled ");

											CheckMenuItem(m_menu, ID_MENU_TDES,MF_BYCOMMAND | MF_UNCHECKED); 
											CheckMenuItem(m_menu, ID_MENU_AES,MF_BYCOMMAND | MF_CHECKED); 
										}
									}


									// Check Output Format
									datapool[0] = 0x60;
									datapool[1] = 0;
									datapool[2] = 2;
									datapool[3] = 0x52;
									datapool[4] = 0x2F;
									
									LRC = 0;
									for(i=0; i<5; i++)
										LRC ^= datapool[i];

									datapool[5] = LRC;

									datapool[6] = 3;	
									
									for(i=0; i<50; i++)
										BufferTmp2[i] = 0;

									BufferLength2 = 50;
								
									MSR.SendCommand_MOIR(datapool, outLength, BufferTmp2, &BufferLength2);	
									
									if(BufferLength2)
									{
										if ((BufferTmp2[5] & 0x10) == 0x10)  // NGA ENVELOPE 
										{											
											bMOIR = false;	
											StrReaderStatus += _T(" NGA Envelope)");											
										}

										else // MOIR ENVELOPE
										{
											bMOIR = true;	
											StrReaderStatus += _T(" MOIR Envelope)");
										}
									}


									SetDecodeMode(1);

								}
							}
						}

						else
							SetDecodeMode(0);
						
						bChecked = true;
					}
				}			
			}
		}
	}
	
	if(m_ulDevIndex >= 30){
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 30; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{		
						KBMode = 1; // USB KB						
						bConnected = true;

						SetDecodeMode(0);

						if (!bChecked)
						{
						
							if (nReader == 2)
								StrReaderStatus = _T("MOIR USB KB Connected ");

							else if (nReader == 5)
							{
								StrReaderStatus = _T("Secure MOIR USB KB Connected ");
					


								const int outLength = 7;
								BYTE datapool[outLength];

								datapool[0] = 0x60;
								datapool[1] = 0;
								datapool[2] = 2;
								datapool[3] = 0x52;
								datapool[4] = 0x7E;
								
								for(i=0; i<5; i++)
									LRC ^= datapool[i];

								datapool[5] = LRC;

								datapool[6] = 3;	

								MSR.SendCommand_MOIR(datapool, outLength, BufferTmp1, &BufferLength1);
									
								if(BufferLength1)
								{
									if (BufferTmp1[5] < 0x33)	// Encryption is off
									{
										bDecryptMode = 0;
										StrReaderStatus += _T(" ( No Encryption )");
									}

									else						// Encryption is on
									{
										// Check Encryption Method
										datapool[0] = 0x60;
										datapool[1] = 0;
										datapool[2] = 2;
										datapool[3] = 0x52;
										datapool[4] = 0x4C;
										
										LRC = 0;
										for(i=0; i<5; i++)
											LRC ^= datapool[i];

										datapool[5] = LRC;

										datapool[6] = 3;	
										MSR.SendCommand_MOIR(datapool, outLength, BufferTmp2, &BufferLength2);

										if(BufferLength2)
										{
											if (BufferTmp2[5] == 0x31)			// TDES
											{
												bDecryptMode = 1;
												StrReaderStatus += _T(" (TDES Encryption Enabled ");

												CheckMenuItem(m_menu, ID_MENU_TDES,MF_BYCOMMAND | MF_CHECKED); 
												CheckMenuItem(m_menu, ID_MENU_AES,MF_BYCOMMAND | MF_UNCHECKED); 
											}

											else if ( BufferTmp2[5] == 0x32)	// AES
											{
												bDecryptMode = 2;
												StrReaderStatus += _T(" (AES Encryption Enabled ");

												CheckMenuItem(m_menu, ID_MENU_TDES,MF_BYCOMMAND | MF_UNCHECKED); 
												CheckMenuItem(m_menu, ID_MENU_AES,MF_BYCOMMAND | MF_CHECKED); 
											}
										}

											
										// Check Output Format
										datapool[0] = 0x60;
										datapool[1] = 0;
										datapool[2] = 2;
										datapool[3] = 0x52;
										datapool[4] = 0x2F;
										
										LRC = 0;
										for(i=0; i<5; i++)
											LRC ^= datapool[i];

										datapool[5] = LRC;

										datapool[6] = 3;	
										
										for(i=0; i<50; i++)
										BufferTmp2[i] = 0;

										BufferLength2 = 50;

									
										MSR.SendCommand_MOIR(datapool, outLength, BufferTmp2, &BufferLength2);	
										
										if(BufferLength2)
										{
											if ((BufferTmp2[5] & 0x10) == 0x10)  // NGA ENVELOPE 
											{	
												bMOIR = false;	
												StrReaderStatus += _T(" NGA Envelope)");
											}

											else // MOIR ENVELOPE
											{
												bMOIR = true;	
												StrReaderStatus += _T(" MOIR Envelope)");
											}
										}

									}
								}

								GetDlgItem(IDC_SCRIPT)->ShowWindow(TRUE);
								bChecked = true;
							}
						}
					}
				}
			}
		}		
	}
	
	if (!bConnected)
	{
		MSR.CloseMSRDevice();
		bChecked = false;
		StrReaderStatus = _T("Please Connect SecureMOIR Reader!");
	}


}


BOOL CKeyInjectModuleDlg::PreTranslateMessage(MSG* pMsg) 
{
	CString strtmp;
	if(pMsg->message==WM_KEYDOWN)
    {
        if(pMsg->wParam==VK_TAB)
        {
            if(!(GetWindowLong(pMsg->hwnd, GWL_STYLE) & ES_WANTRETURN))
                pMsg->wParam=VK_SPACE;
        }
    }

	return CDialog::PreTranslateMessage(pMsg);		
}


bool CKeyInjectModuleDlg::SendCommandRequest(byte* datapool, int outLength)
{
	CString strDevName, StrResponse, StrTmp;
	int	m_ulDevIndex = 0;
	int i, j;
	bool isFound = false;
	bool cmdSucceed = false;

	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;

	emMyItfType2 = ITF_TYPE_USB_HID;
	CMSRItfUSBHID MSR(emMyItfType2);


	BufferLength = 1000;

	// Initiate all values
	for (i=0; i<(int) BufferLength; i++)
		CardDataBuffer[i] = 0;

	// Scan for device interface
	for(m_ulDevIndex = 0; m_ulDevIndex < 30; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy

					MSR.SendCommand_MOIR(datapool, outLength, CardDataBuffer, &BufferLength);
				
					isFound = true;

					break;
				}
			}
		}
	}
	
	if(!isFound)
	{
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID MSR(emMyItfType2);

		for(m_ulDevIndex = 0; m_ulDevIndex < 30; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(50); // make sure the device is not busy.

						MSR.SendCommand_MOIR(datapool, outLength, CardDataBuffer, &BufferLength);		
				
						isFound = true;

						break;
					}
				}
			}
		}		
	}

	if(!isFound)
		MessageBox("Fail to detect device!", _T("Error"), MB_OK);

	if (CardDataBuffer[0] == 0x60)
		cmdSucceed = true;


	// Show command text
	StrResponse = _T("CMD: ");
	for (i=0; i<outLength; i++)
	{
		StrTmp.Format("%02X ", datapool[i]);
		StrResponse += StrTmp;
	}

	for (i=BufferLength; i>0; i--)
	{
		if (CardDataBuffer[i] != 0)
			break;
	}

	// Output all response
	StrResponse += _T("\r\nOUT: ");
	for (j=0; j<i+1; j++)
	{
		StrTmp.Format("%02X ",CardDataBuffer[j]);
		StrResponse += StrTmp;
	}

	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);

	MSR.CloseMSRDevice();

	return cmdSucceed;
}



/**************************************************/
/* Events of Main Menu - General Setting
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetDefault() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 2;
	datapool[3] = 0x53;
	datapool[4] = 0x18;
	
	for(int i=0; i<5; i++)
		LRC ^= datapool[i];

	datapool[5] = LRC;

	datapool[6] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadConfiguration() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 2;
	datapool[3] = 0x52;
	datapool[4] = 0x1F;
	
	for(int i=0; i<5; i++)
		LRC ^= datapool[i];

	datapool[5] = LRC;

	datapool[6] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadFirmware() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 1;
	datapool[3] = 0x39;
	
	for(int i=0; i<4; i++)
		LRC ^= datapool[i];

	datapool[4] = LRC;

	datapool[5] = 3;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{
		int i, j;
		CString StrResponse, StrTmp;
		
		// Get command request and response string
		GetDlgItem(IDC_RESP)->GetWindowText(StrResponse);

		// Get the end of card data
		for (i=BufferLength; i>0; i--)
			if (CardDataBuffer[i] != 0)
				break;

		// Append extra information
		StrResponse += "\r\nFirmware Version: ";
		for (j=3; j<i-1; j++)	
		{
			StrTmp.Format("%C",CardDataBuffer[j]);
			StrResponse += StrTmp;
		}

		// Output with extra information
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	}
}


void CKeyInjectModuleDlg::OnMENUMSREnable() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x1A;
	datapool[5] = 1;
	datapool[6] = 0x31;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;
	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUMSRDisable() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x1A;
	datapool[5] = 1;
	datapool[6] = 0x30;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENURawData() 
{
	const int outLength = 9;
	int Ret;
	BYTE LRC = 0;
	BYTE ORBit = 0x40;
	BYTE datapool[outLength];

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 2;

	datapool[3] = 0x52;
	datapool[4] = 0x11;
	
	for(int i=0; i<5; i++)
		LRC ^= datapool[i];

	datapool[5] = LRC;

	datapool[6] = 3;	
	
	Ret = SendCommandRequest(datapool, 7);

	if (Ret)
	{	
		datapool[2] = 4;
		datapool[3] = 0x53;
		datapool[4] = 0x11;
		datapool[5] = 0x01;
		datapool[6] = HexData[5] | ORBit;
				
		LRC = 0;
		for(int i=0; i<7; i++)
			LRC ^= datapool[i];

		datapool[7] = LRC;

		datapool[8] = 3;	
	
		if (SendCommandRequest(datapool, 9))
		{
			bMOIR = true;	
			CheckMenuItem(m_menu, ID_MENU_MOIR_ENVELOPE,MF_BYCOMMAND | MF_CHECKED); 
			CheckMenuItem(m_menu, ID_MENU_NGA_ENVELOPE,MF_BYCOMMAND | MF_UNCHECKED); 
		}
	}

	else
	{
		StrResponse += _T("\r\nResponse Error!");
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	}
}

void CKeyInjectModuleDlg::OnMENUReadOnInsertionAndWithdrawal() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x1D;
	datapool[5] = 1;
	datapool[6] = 0x31;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadOnInsertion() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x1D;
	datapool[5] = 1;
	datapool[6] = 0x32;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReportOnWithdrawal() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x1D;
	datapool[5] = 1;
	datapool[6] = 0x33;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadOnWithdrawal() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x1D;
	datapool[5] = 1;
	datapool[6] = 0x34;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}




/**************************************************/
/* Events of Main Menu - MSR Security
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetPrePANClrData() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x49;
	datapool[5] = 1;
	datapool[6] = 6;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetPostPANClrData() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x4A;
	datapool[5] = 0x01;
	datapool[6] = 0x03;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetMaskChar() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x4B;
	datapool[5] = 0x01;
	datapool[6] = 0x23;
	
	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSecurityLevel() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 2;
	datapool[3] = 0x52;
	datapool[4] = 0x7E;
	
	for(int i=0; i<5; i++)
		LRC ^= datapool[i];

	datapool[5] = LRC;

	datapool[6] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUGetDeviceSN() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 2;
	datapool[3] = 0x52;
	datapool[4] = 0x4E;
	
	for(int i=0; i<5; i++)
		LRC ^= datapool[i];

	datapool[5] = LRC;

	datapool[6] = 3;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMenuTdes() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x4C;
	datapool[5] = 0x01;
	datapool[6] = 0x31;

	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);

	bDecryptMode = 1;

	bChecked = false;
}

void CKeyInjectModuleDlg::OnMenuAes() 
{
	const int outLength = 9;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 4;
	datapool[3] = 0x53;
	datapool[4] = 0x4C;
	datapool[5] = 0x01;
	datapool[6] = 0x32;

	for(int i=0; i<7; i++)
		LRC ^= datapool[i];

	datapool[7] = LRC;

	datapool[8] = 3;

	SendCommandRequest(datapool, outLength);

	bDecryptMode = 2;

	bChecked = false;
}

void CKeyInjectModuleDlg::OnMENUSetSessionID() 
{
	const int outLength = 16;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 11;
	datapool[3] = 0x53;
	datapool[4] = 0x54;
	datapool[5] = 0x08;
	datapool[6] = 0x55;
	datapool[7] = 0x55;
	datapool[8] = 0x55;
	datapool[9] = 0x55;
	datapool[10] = 0x55;
	datapool[11] = 0x55;
	datapool[12] = 0x55;
	datapool[13] = 0x55;

	for(int i=0; i<14; i++)
		LRC ^= datapool[i];

	datapool[14] = LRC;

	datapool[15] = 3;

	SendCommandRequest(datapool, outLength);
}


void CKeyInjectModuleDlg::OnMENUOriginalEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0xE6;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUEnhancedEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0xE7;

	SendCommandRequest(datapool, outLength);		
}

void CKeyInjectModuleDlg::OnMENUForceEncryptAllTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x84;
	datapool[3] = 0x01;
	datapool[4] = 0x07;
	datapool[5] = 0x03;
	datapool[6] = 0xD0;

	SendCommandRequest(datapool, outLength);			
}

void CKeyInjectModuleDlg::OnActivateAuthentication() 
{
	CString		StrTmp,StrOut;
	BYTE KSNTmp[10];
	BYTE KeyTmp[16];
	BYTE XORKey = 240; // F0
	BOOL bError = false;

	unsigned long counter;
	unsigned char stringKSN[10];

	const int outLength = 10;
	BYTE datapool[outLength];

	unsigned char  k=1;

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 5;
	datapool[3] = 0x52;
	datapool[4] = 0x80;
	datapool[5] = 2;
	datapool[6] = 0x00;
	datapool[7] = 0x00;

	for(int i=0; i<8; i++)
		LRC ^= datapool[i];

	datapool[8] = LRC;

	datapool[9] = 3;

	SendCommandRequest(datapool, outLength);


	// Check KSN from response
	for(i=0; i<10; i++) {
		KSNTmp[i] = CardDataBuffer[3 + i]; // skip first 3 bytes
		KSNglb[i] = KSNTmp[i];
	}

	// Update challenge
	for(i=0; i<16; i++)
		challenge[i] = CardDataBuffer[13 + i]; // skip first 13 bytes


	//Initial key
	if (!bBDK)
	{
		m_str_BDK = StrBDK;
		int len = m_str_BDK.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_BDK.GetAt(2*i),m_str_BDK.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;

	GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);
	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
    CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);
	
	for (i=0; i<16; i++)
		KeyTmp[i] = m_cryptoKey[i]^XORKey;

	if (bDecryptMode == 1) //TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
		TDES_Decryption(challenge, KeyTmp, init_vector, 16);
	}

	else if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		AES_Decryption(challenge, KeyTmp, init_vector, 16);
	}
	
		
	for (i=8; i<10; i++)
	{
		if (KSNTmp[i] != challenge[i-2])
		{
			MessageBox("KSN does not match!");
			break;
		}
	}
}

void CKeyInjectModuleDlg::OnActivateChallengeReply() 
{

	BYTE KSNTmp[10];
	BYTE DataTmp[32];
	BYTE KeyTmp[16];
	BYTE LRC = 0;
	BYTE XORKey = 60; // 3C

	unsigned char  k=1;

	unsigned long counter;
	unsigned char stringKSN[10];

	const int outLength = 24;
	BYTE datapool[outLength];

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 19;

	datapool[3] = 0x53;
	datapool[4] = 0x82;
	datapool[5] = 0x10;
	
	// 6-byte challenge 1
	for(int i=0; i<6; i++)
		DataTmp[i] = challenge[i];

	// 2-byte time information
	DataTmp[6] = 0x00;
	DataTmp[7] = 0x3C; // 60 seconds


	// Check KSN from response
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bBDK)
	{
		m_str_BDK = StrBDK;
		int len = m_str_BDK.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_BDK.GetAt(2*i),m_str_BDK.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;
 
    GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);
	memset(m_cryptoKey, 0, 16);
	CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);
		
	// challenge
	for(i=8; i<16; i++)
		DataTmp[i] = 0xAA;

	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];

	
	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
		TDES_Encryption(DataTmp, KeyTmp, init_vector, 8);
	}

	else if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		AES_Encryption(DataTmp, KeyTmp, init_vector, 16);
	}

	// Encrypted Challenge 
	for(i=0; i<16; i++)
		datapool[6 + i] = DataTmp[i];

	for(i=0; i<22; i++)
		LRC ^= datapool[i];

	datapool[22] = LRC;

	datapool[23] = 3;

	SendCommandRequest(datapool, outLength);

	bActivation = true;
}

void CKeyInjectModuleDlg::OnDeactivateChallengeReply() 
{

	BYTE KSNTmp[10];
	BYTE DataTmp[32];
	BYTE KeyTmp[16];
	BYTE LRC = 0;
	BYTE XORKey = 60; // 3C

	unsigned char  k=1;

	unsigned long   counter;
	unsigned char  stringKSN[10];

	const int outLength = 24;
	BYTE datapool[outLength];

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 19;
	datapool[3] = 0x53;
	datapool[4] = 0x81;
	datapool[5] = 0x10;

	// 6-byte challenge 
	for(int i=0; i<7; i++)
		DataTmp[i] = challenge[8 + i];

	DataTmp[7] = 0x01;

	unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

	// Check KSN from response
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bBDK)
	{
		m_str_BDK = StrBDK;
		int len = m_str_BDK.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_BDK.GetAt(2*i),m_str_BDK.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;
	GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);
	memset(m_cryptoKey, 0, 16);
	CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);

	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];

	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
		TDES_Encryption(DataTmp, KeyTmp, init_vector, 8);
	}

	else //if (bDecryptMode == 2) //
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		AES_Encryption(DataTmp, KeyTmp, init_vector, 16); 
	}


	// Encrypted Challenge 
	for(i=0; i<16; i++)
		datapool[6 + i] = DataTmp[i];

	// calculate LRC
	for (i=0; i<22; i++)
		LRC ^= datapool[i];

	datapool[22] = LRC;

	datapool[23] = 0x03;

	SendCommandRequest(datapool, outLength);
	
	bActivation = false;
}

void CKeyInjectModuleDlg::OnGetReaderStatus() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	BYTE LRC = 0;

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 2;

	datapool[3] = 0x52;
	datapool[4] = 0x83;

	for(int i=0; i<5; i++)
		LRC ^= datapool[i];

	datapool[5] = LRC;

	datapool[6] = 3;

	SendCommandRequest(datapool, outLength);

}

void CKeyInjectModuleDlg::OnDecodeAscii() 
{
	SetDecodeMode(0);
}

void CKeyInjectModuleDlg::OnDecodeHex() 
{
	SetDecodeMode(1);
}


void CKeyInjectModuleDlg::OnMenuGetksn() 
{
	const int outLength = 7;
	bool Ret;
	BYTE LRC = 0;
	BYTE datapool[outLength];

	datapool[0] = 0x60;
	datapool[1] = 0;
	datapool[2] = 2;

	datapool[3] = 0x52;
	datapool[4] = 0x51;
	
	for(int i=0; i<5; i++)
		LRC ^= datapool[i];

	datapool[5] = LRC;

	datapool[6] = 3;			


	Ret = SendCommandRequest(datapool, outLength);

	if (Ret)
	{
		for(int i=0; i<10; i++) 		
			KSNglb[i] = HexData[2 + i]; // skip first 2 bytes
		
	}

}


/**************************************************/
/* Events of Main Menu - Help
/**************************************************/
void CKeyInjectModuleDlg::OnMENUAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();		
}


